<template>
  <section id="arena-pokemon-selection-page">
    <div class="top-screen">
      <div>
        <div
          v-for="(pkmn, index) in pokemons"
          :key="`pkmn-${index}`"
          :class="`pkmn ${pkmn.isSelected ? 'is-selected' : ''}`"
          @click="selectPkmn($event, index)"
        >
          <p>{{pkmn.name}}</p>
          <p>
            <span>100</span>
            <span>{{pkmn.hp}}</span>
          </p>
          <img
            :src="pkmn.numero < 650 ? require(`@/assets/pkmn/front/${pkmn.numero}.png`) : require(`@/assets/pkmn/front/substitute.png`)"
          />
        </div>
      </div>
      <div class="text-box">
        <p></p>
      </div>
    </div>

    <div class="middle-screen"></div>

    <div class="bottom-screen">
      <div class="columns">
        <div class="column">
          <button
            :class=" `button is-primary is-large ${isWaitingForServer ? 'is-loading' : ''}`"
            @click="goToFight()"
            :disabled="pokemons.filter(x => x.isSelected).length !== 3"
          >
            <span class="icon is-medium">
              <font-awesome-icon icon="fist-raised" />
            </span>
            <span>Fight</span>
          </button>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <button class="button is-danger is-large" @click="goback()">
            <span class="icon is-medium">
              <font-awesome-icon icon="backward" />
            </span>
            <span>Return</span>
          </button>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import router from "../router";
import WriteTextBox from "../helper/writeTextBox";

export default {
  name: "arena-pokemon-selection",
  data: function() {
    return {
      pokemons: [],
      pokemonsSelected: [],
      isWaitingForServer: false
    };
  },
  methods: {
    goback() {
      this.$socket.emit("leave-lobby", this.$route?.params?.id);
      router.push("/arena");
    },
    selectPkmn(event, index) {
      if (!this.isWaitingForServer) {
        this.pokemons[index].isSelected = !this.pokemons[index].isSelected;
        if (this.pokemons[index].isSelected) {
          this.pokemonsSelected.push(this.pokemons[index]);
        } else {
          const currIndex = this.pokemonsSelected.findIndex(x => x.id === this.pokemons[index].id);
          if (currIndex > -1) this.pokemonsSelected.splice(currIndex, 1);
        }
        this.$forceUpdate();
      }
    },
    goToFight() {
      console.log("route:" + this.$route?.params?.id);
      this.$socket.emit(
        "player-ready",
        JSON.stringify({
          pokemons: this.pokemonsSelected,
          lobby: this.$route?.params?.id
        })
      );
      this.isWaitingForServer = true;
      this.writeTextBox.run(["Waiting for other player"]);
    }
  },
  computed: {},
  components: {},
  mounted() {
    this.$userService.inventory(
      res => {
        res.data.userInventory.forEach(el => {
          this.pokemons.push(el.idCustomizePokemon);
        });
      },
      err => {
        console.log(err);
      }
    );
    this.writeTextBox = new WriteTextBox();
    this.writeTextBox.run(["Select your 3 Pokémons"]);

    this.$socket.on("all-players-ready", () => {
      router.push(`/arena/${this.$route?.params?.id}/fight`);
    });
  },
  destroyed() {
    this.writeTextBox.destroy();
    this.$socket.off('all-players-ready');
  }
};
</script>


<style scoped lang="scss">
#arena-pokemon-selection-page {
  .top-screen {
    background-image: none !important;
    background-image: url("~@/assets/background-bottom-screen2.png") !important;
    > div:first-child {
      height: calc(100% - (45px * 2));
      display: flex;
      justify-content: center !important;
      flex-direction: row !important;
      flex-wrap: wrap;
      overflow-y: auto !important;
      scrollbar-width: thin;
      > div.pkmn {
        width: 50%;
        font-family: PokemonGb;
        padding: 0.95em 1.5em 0.5em 3em;
        text-align: left;
        height: calc((45px * 2) + 0.5em);
        background-repeat: no-repeat;
        background-size: 100% auto;
        background-position: bottom left;
        color: white;
        display: flex;
        justify-content: space-between;
        flex-direction: column;
        position: relative;
        cursor: pointer;
        background-image: url("~@/assets/pokemon-box.png") !important;
        &.is-selected {
          background-image: url("~@/assets/pokemon-box2.png") !important;
        }
        > p {
          &:first-child {
            padding: 0.5em 0 0 1.2em;
          }
          &:nth-child(2) {
            display: flex;
            justify-content: space-between;
            flex-direction: row;
          }
        }
        > img {
          position: absolute;
          top: 10px;
          left: 20px;
          width: 50px;
          image-rendering: auto;
        }
      }
    }
  }
  .bottom-screen {
  }
}
</style>
